<script lang="ts" setup>
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Checkwork } from '@/types/CheckWork'
import http from '@/services/http'
import { useLoadingStore } from '@/stores/loading'
import checkworkService from '@/services/checkwork'
import { useCheckworkStore } from '@/stores/checkwork'
import { useRoleStore } from '@/stores/role'
const checkworkStore = useCheckworkStore()
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Full Name',
    key: 'fullname',
    value: 'fullname'
  },
  {
    title: 'Date',
    key: 'date',
    value: 'date'
  },
  {
    title: 'Time in',
    key: 'timein',
    value: 'timein'
  },
  {
    title: 'Time out',
    key: 'timeout',
    value: 'timeout'
  },
  {
    title: 'Status',
    key: 'status',
    value: 'status'
  },

  { title: 'Actions', key: 'actions', sortable: false }
]
const loadingStore = useLoadingStore()
const roleStore = useRoleStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const roles = ref()

let editedIndex = -1
let lastId = 4
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    checkworkStore.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await checkworkStore.deleteCheckwork()
  closeDelete()
}
async function editItem(item: Checkwork) {
  if (!item.id) return
  await checkworkStore.getCheckWork(item.id)
  dialog.value = true
}
async function deleteItem(item: Checkwork) {
  if (!item.id) return
  await checkworkStore.getCheckWork(item.id)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    checkworkStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await checkworkStore.saveCheckwork()
  closeDialog()
}

onMounted(async () => {
  await checkworkStore.getCheckworks()
  await roleStore.getRoles()
})
</script>
<template>
  <div>
    <v-data-table :headers="headers" :items="checkworkStore.checkworks">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Checkworks</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props"> New Checkwork </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Checkwork Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="checkworkStore.editedCheckWork.fullname"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Full Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="checkworkStore.editedCheckWork.date"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Date"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="checkworkStore.editedCheckWork.timein"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Timein"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="checkworkStore.editedCheckWork.timeout"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Timeout"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="checkworkStore.editedCheckWork.status"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Status"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4"> </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="checkworkStore.getCheckworks"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
